/*============================================================================
|   Copyright (C) 2001  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   skipcomment.c REV 6 for SQL Query Generator
|
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"

char *skipcomment(FILE *fp)
{



     int count = 0, ch;
     static char buffer[MAX];




 while(count < MAX)
    {

    ch = fgetc(fp);

    //check for EOF and return NULL if it is found
    if( ch == EOF)
    {
       return NULL;
    }


    //use switch to look for comments
    switch (ch)
       {

       case '/':


         if( (ch = fgetc(fp)) == '*')
            {

            //now go to end of comment
            //or quit if EOF is found
            while(1)
                   {

                      ch = fgetc(fp);


                       //look for * then /
                       if( (ch == '*'))
                           {
                             if( (ch = fgetc(fp)) == '/')
                             break;
                           }


                       if(ch == EOF)
                            {
                             fprintf(stderr, "Comment doesn't have an end.\n");
                             exit(1);
                            }


                   }


         }



       break;


       case '-':
         if( (ch = fgetc(fp)) == '-')
              {

                        //if it is an Oracle syle comment, then
                        //just use fgetc until \n or \r is found
                       while( ch != '\r')
                       {

                              ch = fgetc(fp);
                       }

               }
        //might need to unget char here

       break;



       //before putting ch into the buffer, do some checking
       //for spaces, parenthesis, and other punctuation
       default:

          //store alphanumeric and puncuation characters into buffer
          if( (isalnum(ch) != 0 || ispunct(ch) != 0))
              {

                  //store ch to buffer then increment count
                  buffer[count] = ch;

                  //increment count
                  count++;


                      //now see if space is the next character

                      ch = fgetc(fp);
                      if( isspace(ch) != 0)
                      {

                           buffer[count] = '\0';
                           return buffer;
                      }

                      else
                      {

                           fseek(fp, -1, SEEK_CUR);

                       }



              }

       break;



    } //end of switch



} //end of while loop


return NULL;

} //end of function
